﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Controls.Primitives;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace WpfApp
{
	public partial class Window1 : Window
	{
		public Window1()
		{
			InitializeComponent();
			this.KeyDown += new KeyEventHandler(Window1_KeyDown);

			InitializeComponent();

			this.CommandBindings.Add(new CommandBinding(MyCommands.CommandF3,OnMyCommandsExecuted,OnCanMyCommandsExecute));
			// next is in Xaml:
			//this.CommandBindings.Add(new CommandBinding(MyCommands.CommandControlF3, OnMyCommandsExecuted, OnCanMyCommandsExecute));

			InputBindingCollection bindingCollection = new InputBindingCollection();
			bindingCollection.Add(new KeyBinding(MyCommands.CommandF3, Key.F3, ModifierKeys.None));
			// next is in Xaml:
			//bindingCollection.Add(new KeyBinding(MyCommands.CommandControlF3, Key.F3, ModifierKeys.Control));
			this.InputBindings.AddRange(bindingCollection);
		}

		void Window1_KeyDown(object sender, KeyEventArgs e)
		{
			switch (e.Key)
			{
				case Key.F2:
					switch (e.KeyboardDevice.Modifiers)
					{
						case ModifierKeys.None:
							this.ActionF2();
							break;
						case ModifierKeys.Control:
							this.ActionControlF2();
							break;
					}
					break;
			}
		}

		private void MyAlert1(object content)
		{
			RadWindow.Alert(content);
		}

		private void MyAlert2(object sender)
		{
			ContentControl contentControl = sender as ContentControl;
			ContentPresenter contentPresenter = sender as ContentPresenter;
			object content = "unknown sender";
			if (contentPresenter != null && contentPresenter.Content != null)
				content = contentPresenter.Content;
			if (contentControl != null && contentControl.Content != null)
				content = contentControl.Content;
			this.MyAlert1(content);
		}

		private void ActionF2()
		{
			this.MyAlert1("Action on KeyDown-event: F2");
		}

		private void ActionControlF2()
		{
			this.MyAlert1("Action on KeyDown-event: Control+F2");
		}

		private void myButtonHotKey_Click(object sender, RoutedEventArgs e)
		{
			this.MyAlert2(sender);
		}

		private void myButtonControlF2_Click(object sender, RoutedEventArgs e)
		{
			this.ActionControlF2();
		}

		private void myButtonF2_Click(object sender, RoutedEventArgs e)
		{
			this.ActionF2();
		}

		private void OnMyCommandsExecuted(object sender, ExecutedRoutedEventArgs e)
		{
			RoutedUICommand command = e.Command as RoutedUICommand;
			string message = "unknown command";
			if (command != null)
			{
				message = (command.Text ?? command.Name) ?? message;
			}
			this.MyAlert1(message);
		}

		private void OnCanMyCommandsExecute(object sender, CanExecuteRoutedEventArgs e)
		{
			e.CanExecute = true;
		}
	}

	public static class MyCommands
	{
		public static readonly RoutedUICommand CommandF3 =
			new RoutedUICommand("Commands: F3", "Command_F3", typeof(MyCommands));
		public static readonly RoutedUICommand CommandControlF3 =
			new RoutedUICommand("Commands: ControlF3", "Command_ControlF3", typeof(MyCommands));
	}
}
